//nacteni a zapis konfigurace
var rCfg:record
      //na zacatku popisu je vzdy [jmeno prvku ve fomulari] a jmeno promenne
      //v Spoiler.config.pas
      sFilename:string;      //jmeno souboru, z ktereho bylo nacteno
      bSilent:boolean;       //[bSilent], SILENT priznak ticheho rezimu
      eEraseOfflineDir:T_ERASEDIR;   //[rEraseOffline], CLEAR_OFFLINE_BEFORE, CLEAR_OFFLINE_AFTER
                                  //  priznak mazani offline adresare
                                  //  (0=na zacatku, 1=na konci,
                                  //  2=na zacatku i na konci, 3=nikdy)
      eEraseTransformDir:T_ERASEDIR;   //[rEraseTransform], CLEAR_TRANSFORM_BEFORE,
                                  //  priznak mazani adresare pro transformovane
                                  //  obrazky (0=na zacatku, 1=na konci,
                                  //  2=na zacatku i na konci, 3=nikdy)
      //nacitani dat -----------------------------
      eUpdate:T_UPDATETEST;  //[rUpdate], LISTING_IMPORT priznak, kdy aktualizovat
                             //  listing (0=kdyz kes nema TAG gcimage, 1=vzdy, 2=nikdy
                             //  3=pokud je listing starsi nez nastavena hodnota [eDays])
      iDays:integer;         //[eDays], LISTING_OLDER maximalni povolene stari
                             //  listingu v dnech
      eUpdateListing:T_UPDATELISTING;//[cbUpdate], DOWNLOAD
                             //  zpusob aktualizace listingu (0=GC.Live, 1=Geojarry)
      bUseOfflineDir:boolean;//[bOffline], USE_GG_OFFLINE priznak hledani obrazku
                             //  v geogetim adresari offline
      ePattern:T_PATTERNTYPE;//[rPattern], REGEXP zpusob pouziti vzoru pro
                             //  rozpoznani jmena obrazku se spoilery (0=substring, 1=regex)
      sPatternRegex:string;  //[ePattern], SPOILER_PATTERN vzor pro rozpoznani
                             //  jmena obrazku se spoilerem
      sPatternSubstr:string; //[ePattern], SPOILER_PATTERN vzor pro rozpoznani
                             //  jmena obrazku se spoilerem
      bReloadImg:boolean;//[bReloadImg], IMG_RELOAD priznak vynuceneho
                             //  nacteni obrazku z webu i kdyz je nalezen mezi
                             //  drive nactenymi
                             //  --- asi zbytecne, resi to promenne iErase* ---
      //export dat -------------------------------
      eExportType:T_EXPORTTYPE;   //[cbExportType], STYLE
                             //  zpusob exporty (0=POI, 1=IMG, 2=IMC, 3=ATTACH)
      sPoiDir:string;        //[eDirOut], DIR_SPOILER vystupni adresar pro GPX
                             //  (tento adresar se zadava do POILoaderu ne gpigen
      sImgDir:string;        //[eDirOut],DIR_IMG vystupni adresar pro IMG/ATTACH
                             //  (pro prime nahrani obrazku do GPS)
      bSubdir:boolean;       //[cbSubdir], SPOILER_SEPARATELY
                             //  priznak ulozeni obrazku do podadresare Soiler
                             //  v adresari <GC kod kese> (vzdy zapnuto pro ATTACH)
      sOutFilename:string;   //[eFilename], FILE_EXPORT jmeno souboru pro vystup GPX
      iNameMaxLength:integer;//[eNameLength], FILENAME_LENGTH maximalni delka jmena
                             //  souboru s obrazekm (bez pripony)
      bResize:boolean;       //[bResize] IMG_RESIZE priznak zmeny velikosti velkych obrazku
      bAutorotate:boolean;   //[bAutorotate], IMG_AUROTOTATE priznak automatickeho
                             //  natoceni obrazu
      bAspectRatio:boolean;  //[bAspectRatio], IMG_USE_RATIO priznak zachovani
                             //  pomeru stran obrazku
      iWidth:integer;        //[eWidth], IMG_WIDTH maximalni sirka obrazku (displeje GPS)
      iHeight:integer;       //[eHeight], IMG_HEIGHT maximalni vyska obrazku (displeje GPS)
      eGps:T_GPSTYPE;        //[cbGps] typ pristroje (0=Oregon, 1=Dakota, 2=jiny)
      sIconPathname:string;  //[eIconFile], FILE_ICON cesta a jmeno obrazku
                             //  s ikonou pro zobrazeni waypointu na mape v GPS
      iDistance:integer;     //[eDistance], POI_DISTANCE vzdalenost waypointu od
                             //  ikony kese (v metrech)
      iAzimut:integer;       //[eAzimut], POI_AZIMUT uhel otaceni ikon spoileru
                             //  kolem ikony kese na mape, pokud je spoileru ke
                             //  kesi vice (ve stupnich)
      bCorrected:boolean;    //[bCorrected], POSITION_CORRECTED priznak pouziti
                             //  korigovanych souradnic misto vychozich (pro
                             //  ziskani polohy waypointu)
      bHint:boolean;         //[bHint], INCLUDE_HINT priznak vlozeni hintu k popisu
                             //  spoileru do GPX
      bIdTag:boolean;        //[bIdTag], INCLUDE_IDTAG priznak vlozeni IDTAG
                             //  (napr. TM2A) k popisu spoileru do GPX
    end;
    iLastExportType:integer; //posledni volba typu exportu pred jeho zmenou
    iLastPatternType:integer;//posledni typ vyhledavani (regex/substring)

procedure CfgEmpty; //vycisti strukturu cfg
begin
  rCfg.sFilename:='';    rCfg.bSilent:=false;
  rCfg.eEraseOfflineDir:=ENUM_NEVER;   rCfg.eEraseTransformDir:=ENUM_NEVER;
  rCfg.eUpdate:=ENUM_DAYS;             rCfg.iDays:=0;
  rCfg.eUpdateListing:=ENUM_GCLIVE;    rCfg.bUseOfflineDir:=true;
  rCfg.ePattern:=ENUM_SUBSTRING;       rCfg.sPatternRegex:='';      rCfg.sPatternSubstr:='';
  rCfg.bReloadImg:=false;
  rCfg.eExportType:=ENUM_NOEXPORT;     rCfg.sPoiDir:='';            rCfg.sImgDir:='';
  rCfg.bSubdir:=false;                 rCfg.sOutFilename:='';       rCfg.iNameMaxLength:=64;
  rCfg.bResize:=false;                 rCfg.bAutorotate:=true;      rCfg.bAspectRatio:=true;
  rCfg.iWidth:=0;                      rCfg.iHeight:=0;             rCfg.eGps:=ENUM_NOGPS;
  rCfg.sIconPathname:='';              rCfg.iDistance:=0;           rCfg.iAzimut:=0;
  rCfg.bCorrected:=true;               rCfg.bHint:=true;            rCfg.bIdTag:=true;
end;

//nacte soubor, pokud budou existovat nenastavene hodnoty, doplni je
//nactenim ze souboru Stator.default.oas
function CfgRead(sFile:string; bDefault:boolean):boolean;
var s,sRow,sName,sVal:string;
begin
  Result:=true;
  if(not bDefault) then begin//napred nacteme implicitni a pak prepiseme hodnotama z konkretniho souboru
    CfgEmpty();
    CfgRead(GetMyDir()+'Spoiler.config.pas',true);
  end
  else rCfg.sFilename:=sFile;
  s:=Trim(FileToString(sFile));
  while(s<>'') do begin
    sRow:=Fetch(s,CRLF);
    if(Pos('//',sRow)=1) then continue; //ignorujeme zapoznamkovane radky
    sName:=UpperCase(Fetch(sRow,'='));
    sRow:=ReplaceString(Copy(sRow,2,Length(sRow)),'''''','&&_UVO_&&');
    sVal:=ReplaceString(Fetch(sRow,''''),'&&_UVO_&&','''''');
    if(sName='') or (sName='CONST') then continue;
    //prazdny radek a pocatek definice konstant ignorujeme
    //prepiseme konstantu do promenne
{$ifdef DEBUG_HELPER}
  //LDH('CfgRead: konstanta: '+sName+'='+sVal);
{$endif}
    case sName of
    'SILENT': rCfg.bSilent:=((UpperCase(sVal)='YES') or (sVal='1'));
    'CLEAR_OFFLINE_BEFORE':  if(rCfg.eEraseOfflineDir=ENUM_END) then rCfg.eEraseOfflineDir:=ENUM_ALWAYS
                             else if(rCfg.eEraseOfflineDir=ENUM_NEVER) then rCfg.eEraseOfflineDir:=ENUM_START;
    'CLEAR_OFFLINE_AFTER':  if(rCfg.eEraseOfflineDir=ENUM_START) then rCfg.eEraseOfflineDir:=ENUM_ALWAYS
                             else if(rCfg.eEraseOfflineDir=ENUM_NEVER) then rCfg.eEraseOfflineDir:=ENUM_END;
    'CLEAR_TRANSFORM_BEFORE':if(rCfg.eEraseTransformDir=ENUM_END) then rCfg.eEraseTransformDir:=ENUM_ALWAYS
                             else if(rCfg.eEraseTransformDir=ENUM_NEVER) then rCfg.eEraseTransformDir:=ENUM_START;
    'CLEAR_TRANSFORM_AFTER':if(rCfg.eEraseTransformDir=ENUM_START) then rCfg.eEraseTransformDir:=ENUM_ALWAYS
                             else if(rCfg.eEraseTransformDir=ENUM_NEVER) then rCfg.eEraseTransformDir:=ENUM_END;
    'LISTING_IMPORT': case UpperCase(sVal) of
                      'NOTAG': rCfg.eUpdate:=ENUM_TAG_GCIMAGE;
                      'YES':   rCfg.eUpdate:=ENUM_ALWAYS;
                      'NO':    rCfg.eUpdate:=ENUM_NEVER;
                      else begin
                             rCfg.eUpdate:=ENUM_DAYS;
                             ShowMessage(_('ERR: invalid value for')+' '+sName+': '+sVal);
                           end;
                      end;
    'LISTING_OLDER':  rCfg.iDays:=StrToInt(sVal);
    'DOWNLOAD':       case UpperCase(sVal) of
                      'GEOJARRY': rCfg.eUpdateListing:=ENUM_GEOJARRY;
                      'GCLIVE':   rCfg.eUpdateListing:=ENUM_GCLIVE;
                      else begin
                             rCfg.eUpdateListing:=ENUM_GCLIVE;
                             ShowMessage(_('ERR: invalid value for')+' '+sName+': '+sVal);
                           end;
                      end;
    'USE_GG_OFFLINE': rCfg.bUseOfflineDir:=((UpperCase(sVal)='YES') or (sVal='1'));
    'REGEXP':         if(UpperCase(sVal)='YES') or (sVal='1') then rCfg.ePattern:=ENUM_REGEX
                      else rCfg.ePattern:=ENUM_SUBSTRING;
    'SPOILER_PATTERN':begin //zastarale, nepouzivame, ale zkusime spravne pridelit
                        if(Pos('*',sVal)>=1) then rCfg.sPatternRegex:=sVal
                        else  rCfg.sPatternSubstr:=sVal;
                      end;
    'SPOILER_PATTERN_REGEX':rCfg.sPatternRegex:=sVal;
    'SPOILER_PATTERN_SUBSTR':rCfg.sPatternSubstr:=sVal;
    'IMG_RELOAD':     rCfg.bReloadImg:=((UpperCase(sVal)='YES') or (sVal='1'));
    //----- export
    'STYLE':          case UpperCase(sVal) of
                      'POI':  rCfg.eExportType:=ENUM_POI;
                      'IMG':  rCfg.eExportType:=ENUM_IMG;
                      'IMC':  rCfg.eExportType:=ENUM_IMC;
                      'ATTACH': rCfg.eExportType:=ENUM_ATTACH;
                      else begin
                             rCfg.eExportType:=ENUM_NOEXPORT;
                             ShowMessage(_('ERR: invalid value for')+' '+sName+': '+sVal);
                           end;
                      end;
    'DIR_SPOILER':   rCfg.sPoiDir:=sVal;
    'DIR_IMG':       rCfg.sImgDir:=sVal;
    'SPOILER_SEPARATELY': rCfg.bSubdir:=((UpperCase(sVal)='YES') or (sVal='1'));
    'FILE_EXPORT':   rCfg.sOutFilename:=sVal;
    'FILENAME_LENGTH': rCfg.iNameMaxLength:=StrToInt(sVal);
    'RESIZE':          rCfg.bResize:=((UpperCase(sVal)='YES') or (sVal='1'));
    'IMG_AUROTOTATE':  rCfg.bAutorotate:=((UpperCase(sVal)='YES') or (sVal='1'));
    'IMG_USE_RATIO':   rCfg.bAspectRatio:=((UpperCase(sVal)='YES') or (sVal='1'));
    'IMG_WIDTH':       rCfg.iWidth:=StrToInt(sVal);
    'IMG_HEIGHT':      rCfg.iHeight:=StrToInt(sVal);
    'GPS_TYPE':        case UpperCase(sVal) of
                       'DAKOTA':  rCfg.eGPS:=ENUM_DAKOTA;
                       'OREGON':  rCfg.eGPS:=ENUM_OREGON;
                       else       rCfg.eGPS:=ENUM_NOGPS;
                       end;
    'FILE_ICON':       rCfg.sIconPathname:=sVal;
    'POI_DISTANCE':    rCfg.iDistance:=StrToInt(sVal);
    'POI_AZIMUT':      rCfg.iAzimut:=StrToInt(sVal);
    'POSITION_CORRECTED': rCfg.bCorrected:=((UpperCase(sVal)='YES') or (sVal='1'));
    'INCLUDE_HINT':    rCfg.bHint:=((UpperCase(sVal)='YES') or (sVal='1'));
    'INCLUDE_IDTAG':   rCfg.bIdTag:=((UpperCase(sVal)='YES') or (sVal='1'));
    else ShowMessage(_('ERR: unknown constant:')+' '+sName);
    end;
  end;
end;

function IntToYesNo(i:integer):string;
begin
  Result:='''0''';
  if(i=1) then Result:='''1''';
end;

function CfgWrite:boolean;
var sOut,sFile:string;
begin
  Result:=true;
  //zjistime soubor, kam zapsat
  sFile:=rCfg.sFilename;
  if(not OpenDlg(
    _('Configuration file location'), 
    DIR_SPOILER,
    'ofHideReadOnly,ofOverwritePrompt,ofNoNetworkButton',
    _('Config files')+' (*.config.pas)|*.config.pas',
    sFile)) then exit;
  //ke kazde promenne musime doplnit popis, aby to bylo editovatelne i pres Plugin managera
  sOut:='const'+CRLF+CRLF;
  sOut:=sOut+'////////// Start/End /////////'+CRLF+CRLF;
  sOut:=sOut+'SILENT='+IntToYesNo(rCfg.bSilent as integer)
    +';     '+_('//1 = silent mode, no messages - useful for Combine')+CRLF;
  if(rCfg.eEraseOfflineDir=ENUM_START) or (rCfg.eEraseOfflineDir=ENUM_ALWAYS) then
    sOut:=sOut+'CLEAR_OFFLINE_BEFORE=''1'';'
  else sOut:=sOut+'CLEAR_OFFLINE_BEFORE=''0'';';
  sOut:=sOut+'     '+_('//1 = clear offline directory at start')+CRLF;
  if(rCfg.eEraseOfflineDir=ENUM_END) or (rCfg.eEraseOfflineDir=ENUM_ALWAYS) then
    sOut:=sOut+'CLEAR_OFFLINE_AFTER=''1'';'
  else sOut:=sOut+'CLEAR_OFFLINE_AFTER=''0'';';
  sOut:=sOut+'     '+_('//1 = clear offline directory at end')+CRLF;
  if(rCfg.eEraseTransformDir=ENUM_START) or (rCfg.eEraseTransformDir=ENUM_ALWAYS) then
    sOut:=sOut+'CLEAR_TRANSFORM_BEFORE=''1'';'
  else sOut:=sOut+'CLEAR_TRANSFORM_BEFORE=''0'';';
  sOut:=sOut+'     '+_('//1 = clear transform directory at start')+CRLF;
  if(rCfg.eEraseTransformDir=ENUM_END) or (rCfg.eEraseTransformDir=ENUM_ALWAYS) then
    sOut:=sOut+'CLEAR_TRANSFORM_AFTER=''1'';'
  else sOut:=sOut+'CLEAR_TRANSFORM_AFTER=''0'';';
  sOut:=sOut+'     '+_('//1 = clear transform directory at end')+CRLF;

  sOut:=sOut+CRLF+'////////// Import /////////'+CRLF+CRLF;

  case rCfg.eUpdate of
  ENUM_TAG_GCIMAGE: sOut:=sOut+'LISTING_IMPORT=''NoTag'';';
  ENUM_ALWAYS:      sOut:=sOut+'LISTING_IMPORT=''Yes'';';
  ENUM_NEVER:       sOut:=sOut+'LISTING_IMPORT=''No'';';
  else              sOut:=sOut+'LISTING_IMPORT=''NoTag'';';
  end;
  sOut:=sOut+'     '+_('//NoTag/Yes/No - !!!! see documentation !!!')+CRLF;
  sOut:=sOut+'LISTING_OLDER='''+IntToStr(rCfg.iDays)
    +''';     '+_('//update listings older than X days  !!!! see documentation !!!')+CRLF;
  case rCfg.eUpdateListing of
  ENUM_GEOJARRY: sOut:=sOut+'DOWNLOAD=''Geojarry'';';
  ENUM_GCLIVE:   sOut:=sOut+'DOWNLOAD=''GCLive'';';
  else           sOut:=sOut+'DOWNLOAD=''GCLive'';';
  end;
  sOut:=sOut+'     '+_('//download via GCLive, Geojarry')+CRLF;
  sOut:=sOut+'USE_GG_OFFLINE='+IntToYesNo(rCfg.bUseOfflineDir as integer)
    +';     '+_('//searching for spoilers in GeoGet offline directory')+CRLF;
  //if(IntToYesNo((rCfg.ePattern=ENUM_REGEX) as integer) then rCfg.sPatternRegex:=
  sOut:=sOut+'REGEXP='+IntToYesNo((rCfg.ePattern=ENUM_REGEX) as integer)
    +';     '+_('//1=using SPOILER_PATTERN_REGEX, 0=using SPOILER_PATTERN_SUBSTR')+CRLF;
  sOut:=sOut+'SPOILER_PATTERN_REGEX='''+rCfg.sPatternRegex
    +''';     '+_('//patterns for regex, separated by comma')+CRLF;
  sOut:=sOut+'SPOILER_PATTERN_SUBSTR='''+rCfg.sPatternSubstr
    +''';     '+_('//pattern for substring, separated by comma')+CRLF;
  sOut:=sOut+'IMG_RELOAD='+IntToYesNo(rCfg.bReloadImg as integer)+
    +';     '+_('//1=allways read image from web')+CRLF;

  sOut:=sOut+CRLF+'////////// Export /////////'+CRLF+CRLF;

  case rCfg.eExportType of
  ENUM_POI: sOut:=sOut+'STYLE=''POI'';';
  ENUM_IMG: sOut:=sOut+'STYLE=''IMG'';';
  ENUM_IMC: sOut:=sOut+'STYLE=''IMC'';';
  ENUM_ATTACH: sOut:=sOut+'STYLE=''ATTACH'';';
  end;
  sOut:=sOut+'     '+_('//POI=GPX for POILoader or gpigen, IMC=pictures in *.imc database, IMG=pictures in separate directory (Geocaching with Photos), ATTACH=Images will be stored as an annex to the cache directory DATADIR\attach\...')+CRLF;
  sOut:=sOut+'DIR_SPOILER='''+rCfg.sPoiDir+''';     '+_('//directory for generating (POILoader/gpigen start directory)')+CRLF;
  sOut:=sOut+'DIR_IMG='''+rCfg.sImgDir+''';     '+_('//directory for structure with pictures loaded to GPS directly (Geocaching with Photos)')+CRLF;
  sOut:=sOut+'SPOILER_SEPARATELY='+IntToYesNo(rCfg.bSubdir as integer)
    +';     '+_('//1=spoiler pictures in subdirectory "Spoiler"')+CRLF;
  sOut:=sOut+'FILE_EXPORT='''+rCfg.sOutFilename+''';     '+_('//GPX filename (created in DIR_SPOILER)')+CRLF;
  sOut:=sOut+'FILENAME_LENGTH='''+IntToStr(rCfg.iNameMaxLength)
    +''';     '+_('//spoiler image - max length of file name (without .jpg)')+CRLF;
  sOut:=sOut+'RESIZE='+IntToYesNo(rCfg.bResize as integer)
    +';     '+_('//1=resize large images')+CRLF;
  sOut:=sOut+'IMG_AUROTOTATE='+IntToYesNo(rCfg.bAutorotate as integer)
    +';     '+_('//1=autorotate')+CRLF;
  sOut:=sOut+'IMG_USE_RATIO='+IntToYesNo(rCfg.bAspectRatio as integer)
    +';     '+_('//keep aspect ratio of original image')+CRLF;
  sOut:=sOut+'IMG_WIDTH='''+IntToStr(rCfg.iWidth)+''';     '+_('//max width of spoiler picture saved')+CRLF;
  sOut:=sOut+'IMG_HEIGHT='''+IntToStr(rCfg.iHeight)+''';     '+_('//max height of spoiler picture saved')+CRLF;
  case rCfg.eGPS of
  ENUM_DAKOTA: sOut:=sOut+'GPS_TYPE=''DAKOTA'';';
  ENUM_OREGON: sOut:=sOut+'GPS_TYPE=''OREGON'';';
  else         sOut:=sOut+'GPS_TYPE=''???'';';
  end;
  sOut:=sOut+'     '+_('//GPS type for automatic picture resize')+CRLF;
  sOut:=sOut+'FILE_ICON='''+rCfg.sIconPathname+''';     '+_('//icon displayed on GPS map')+CRLF;
  sOut:=sOut+'POI_DISTANCE='''+IntToStr(rCfg.iDistance)+''';     '+_('//distance of POI waypoint from cache coordinates (m)')+CRLF;
  sOut:=sOut+'POI_AZIMUT='''+IntToStr(rCfg.iAzimut)+''';     '+_('//step of azimuth for next spoiler on the same cache')+CRLF;
  sOut:=sOut+'POSITION_CORRECTED='+IntToYesNo(rCfg.bCorrected as integer)
    +';     '+_('//1=spoiler icon near corrected coordinates (final, if exists)')+CRLF;
  sOut:=sOut+'INCLUDE_HINT='+IntToYesNo(rCfg.bHint as integer)
    +';     '+_('//include hint into waypoint description')+CRLF;
  sOut:=sOut+'INCLUDE_IDTAG='+IntToYesNo(rCfg.bIdTag as integer)
    +';     '+_('//include short info (type, size, ... ie. TM22) into waypoint description')+CRLF;
  StringToFile(sOut,sFile);
end;

procedure CfgToDlg;
begin
  GGForm_eCfgFile.Text:=rCfg.sFilename;
  //start/end
  GGForm_bSilent.Checked:=rCfg.bSilent;
  GGForm_rEraseOffline.ItemIndex:=(rCfg.eEraseOfflineDir as integer);
  GGForm_rEraseTransform.ItemIndex:=(rCfg.eEraseTransformDir as integer);
  //import
  GGForm_rUpdate.ItemIndex:=(rCfg.eUpdate as integer);
  GGForm_eDays.Text:=IntToStr(rCfg.iDays);
  GGForm_cbUpdate.ItemIndex:=(rCfg.eUpdateListing as integer);
  GGForm_bOffline.Checked:=rCfg.bUseOfflineDir;
  GGForm_rPattern.ItemIndex:=(rCfg.ePattern as integer);
  if(rCfg.ePattern=ENUM_REGEX) then GGForm_ePattern.Text:=rCfg.sPatternRegex
  else GGForm_ePattern.Text:=rCfg.sPatternSubstr;
  iLastPatternType:=GGForm_rPattern.ItemIndex;
  GGForm_bReloadImg.Checked:=rCfg.bReloadImg;
  //export
  GGForm_cbExportType.ItemIndex:=(rCfg.eExportType as integer);
    iLastExportType:=GGForm_cbExportType.ItemIndex;
  if(rCfg.eExportType=ENUM_POI) then GGForm_eDirOut.Text:=rCfg.sPoiDir
  else GGForm_eDirOut.Text:=rCfg.sImgDir;
  GGForm_cbSubdir.ItemIndex:=(rCfg.bSubdir as integer);
  GGForm_eFilename.Text:=rCfg.sOutFilename;
  GGForm_eNameLength.Text:=IntToStr(rCfg.iNameMaxLength);
  GGForm_bResize.Checked:=rCfg.bResize;
  GGForm_bAutorotate.Checked:=rCfg.bAutorotate;
  GGForm_bAspectRatio.Checked:=rCfg.bAspectRatio;
  GGForm_eWidth.Text:=IntToStr(rCfg.iWidth);
  GGForm_eHeight.Text:=IntToStr(rCfg.iHeight);
  GGForm_cbGPS.ItemIndex:=(rCfg.eGps as integer);
  GGForm_eIconFile.Text:=rCfg.sIconPathname;
  GGForm_eDistance.Text:=IntToStr(rCfg.iDistance);
  GGForm_eAzimut.Text:=IntToStr(rCfg.iAzimut);
  GGForm_bCorrected.Checked:=rCfg.bCorrected;
  GGForm_bHint.Checked:=rCfg.bHint;
  GGForm_bIdTag.Checked:=rCfg.bIdTag;
end;

procedure CfgFromDlg;
begin
  rCfg.sFilename:=GGForm_eCfgFile.Text;
  //start/end
  rCfg.bSilent:=GGForm_bSilent.Checked;
  rCfg.eEraseOfflineDir:=(GGForm_rEraseOffline.ItemIndex as T_ERASEDIR);
  rCfg.eEraseTransformDir:=(GGForm_rEraseTransform.ItemIndex as T_ERASEDIR);
  //import
  rCfg.eUpdate:=(GGForm_rUpdate.ItemIndex as T_UPDATETEST);
  rCfg.iDays:=StrToInt(Trim(GGForm_eDays.Text));
  rCfg.eUpdateListing:=(GGForm_cbUpdate.ItemIndex as T_UPDATELISTING);
  rCfg.bUseOfflineDir:=GGForm_bOffline.Checked;
  rCfg.ePattern:=(GGForm_rPattern.ItemIndex as T_PATTERNTYPE);
  //z formulare ulozime jen aktualni typ stringu, ten druhy je tam z inicializace
  //nebo z predchozi zmeny
  if(rCfg.ePattern=ENUM_REGEX) then rCfg.sPatternRegex:=Trim(GGForm_ePattern.Text)
  else rCfg.sPatternSubstr:=Trim(GGForm_ePattern.Text);
  rCfg.bReloadImg:=GGForm_bReloadImg.Checked;
  //export
  rCfg.eExportType:=(GGForm_cbExportType.ItemIndex as T_EXPORTTYPE);
  if(rCfg.eExportType=ENUM_POI) then rCfg.sPoiDir:=ReplaceString(Trim(GGForm_eDirOut.Text),GEOGET_DATADIR,'.')
  else rCfg.sImgDir:=ReplaceString(Trim(GGForm_eDirOut.Text),GEOGET_DATADIR,'.');
  rCfg.bSubdir:=(GGForm_cbSubdir.ItemIndex=1);
  rCfg.sOutFilename:=Trim(GGForm_eFilename.Text);
  rCfg.iNameMaxLength:=StrToInt(Trim(GGForm_eNameLength.Text));
  rCfg.bResize:=GGForm_bResize.Checked;
  rCfg.bAutorotate:=GGForm_bAutorotate.Checked;
  rCfg.bAspectRatio:=GGForm_bAspectRatio.Checked;
  rCfg.iWidth:=StrToInt(Trim(GGForm_eWidth.Text));
  rCfg.iHeight:=StrToInt(Trim(GGForm_eHeight.Text));
  rCfg.eGps:=(GGForm_cbGPS.ItemIndex as T_GPSTYPE);
  rCfg.sIconPathname:=ReplaceString(Trim(GGForm_eIconFile.Text),GEOGET_DATADIR,'.');
  rCfg.iDistance:=StrToInt(Trim(GGForm_eDistance.Text));
  rCfg.iAzimut:=StrToInt(Trim(GGForm_eAzimut.Text));
  rCfg.bCorrected:=GGForm_bCorrected.Checked;
  rCfg.bHint:=GGForm_bHint.Checked;
  rCfg.bIdTag:=GGForm_bIdTag.Checked;
end;

procedure OnChange(sender:TObject);
begin
  GGForm_GroupPoi.Visible:=((GGForm_cbExportType.ItemIndex as T_EXPORTTYPE)=ENUM_POI);
  GGForm_sFilename.Visible:=GGForm_GroupPoi.Visible;
  GGForm_eFilename.Visible:=GGForm_GroupPoi.Visible;
  GGForm_cbGPS.Visible:=GGForm_bResize.Checked;
//LDH('iLastExportType='+IntToStr(iLastExportType)+', ItemIndex='+IntToStr(GGForm_cbExportType.ItemIndex));
  //pokud je zmena typu, nastavime spravny adresar
  if(iLastExportType<>GGForm_cbExportType.ItemIndex) then begin
    if((iLastExportType as T_EXPORTTYPE)=ENUM_POI) then begin
//LDH('Stare je POI, nove IMG');
      rCfg.sImgDir:=GGForm_eDirOut.Text;  //uchovat adresar pro obrazky
      GGForm_eDirOut.Text:=rCfg.sPoiDir;  //a zobrazit adresar pro POI
    end
    else if((GGForm_cbExportType.ItemIndex as T_EXPORTTYPE)=ENUM_POI) then begin
//LDH('Stare je IMG, nove POI');
      rCfg.sPoiDir:=GGForm_eDirOut.Text;  //uchovat adresar pro POI
      GGForm_eDirOut.Text:=rCfg.sImgDir;  //a zobrazit adresar pro obrazky
    end;
  end;
  if(iLastPatternType<>GGForm_rPattern.ItemIndex) then begin
    if((iLastPatternType as T_PATTERNTYPE)=ENUM_REGEX) then begin
//LDH('Stare je REGEX, nove SUBSTR');
      //protoze nasledujici nastaveni vyvola OnChange(), musime ulozit hodnotu ted
      iLastPatternType:=GGForm_rPattern.ItemIndex;
      rCfg.sPatternRegex:=GGForm_ePattern.Text;  //uchovat pattern
      GGForm_ePattern.Text:=rCfg.sPatternSubstr;  //a zobrazit substring
    end
    else begin
//LDH('Stare je SUBSTR, nove REGEX');
      //protoze nasledujici nastaveni vyvola OnChange(), musime ulozit hodnotu ted
      iLastPatternType:=GGForm_rPattern.ItemIndex;
      rCfg.sPatternSubstr:=GGForm_ePattern.Text;  //uchovat pattern
      GGForm_ePattern.Text:=rCfg.sPatternRegex;  //a zobrazit substring
    end;
  end;
  GGFOrm_eDirOut.Visible:=(((GGForm_cbExportType.ItemIndex as T_EXPORTTYPE)<>ENUM_ATTACH)
                         and ((GGForm_cbExportType.ItemIndex as T_EXPORTTYPE)<>ENUM_IMC));
  GGFOrm_butDir.Visible:=(((GGForm_cbExportType.ItemIndex as T_EXPORTTYPE)<>ENUM_ATTACH)
                         and ((GGForm_cbExportType.ItemIndex as T_EXPORTTYPE)<>ENUM_IMC));
  GGForm_cbSubdir.Visible:=((GGForm_cbExportType.ItemIndex as T_EXPORTTYPE)=ENUM_IMG);
  GGForm_eWidth.Visible:=(GGForm_bResize.Checked and
    ((GGForm_cbGPS.ItemIndex=-1) or ((GGForm_cbGPS.ItemIndex as T_GPSTYPE)=ENUM_NOGPS)));
  GGForm_eHeight.Visible:=GGForm_eWidth.Visible;
  GGForm_sWidth.Visible:=GGForm_eWidth.Visible;
  GGForm_sHeight.Visible:=GGForm_eWidth.Visible;
  GGForm_eDays.Visible:=((GGForm_rUpdate.ItemIndex as T_UPDATETEST)=ENUM_DAYS);
  GGForm_cbUpdate.Visible:=((GGForm_rUpdate.ItemIndex as T_UPDATETEST)<>ENUM_NOUPDATE);
  GGForm_butSave.Enabled:=true;
  iLastExportType:=GGForm_cbExportType.ItemIndex; //zapamatujeme si pro pristi kontrolu
end;

procedure butSaveOnClick(sender:TObject);
begin
  CfgFromDlg();
  CfgWrite();
end;

procedure SaveIfNeed;
begin
  if(GGForm_butSave.Enabled) then butSaveOnClick(nil);
end;

procedure butNoSaveOnClick(sender:TObject);
begin
  GGForm_butSave.Enabled:=false;
end;

procedure butCfgFileOnClick(sender:TObject);
var sFile:string;
begin
  SaveIfNeed();
  sFile:=rCfg.sFilename;
  if(not OpenDlg(
    _('Configuration file'),
    DIR_SPOILER,
    'ofFileMustExist,ofHideReadOnly,ofNoNetworkButton',
    _('Config files')+' (*.config.pas)|*.config.pas',
    sFile)) then exit;
  rCfg.sFilename:=sFile;
  CfgRead(sFile,false);
end;

procedure butDirOnClick(sender:TObject); //zmena vystupniho adresare
var sDir:string;
begin
  sDir:=GGForm_eDirOut.Text;
  sDir:=SelectDir(sDir,_('Directory for spoiler pictures')); 
  if(sDir<>GGForm_eDirOut.Text) and (sDir<>'') then begin
    GGForm_eDirOut.Text:=sDir;
    GGForm_butSave.Enabled:=true;
  end;
end;

procedure butIconFileOnClick(sender:TObject); //soubor s ikonou Spoileru pro mapu
var sFile:string;
begin
  sFile:=GGForm_eIconFile.Text;
  if(not OpenDlg(
    _('Icon file for waypoint on map'), //### Soubor s ikonou pro Waypoint na mape
    DIR_SPOILER,
    'ofFileMustExist,ofHideReadOnly,ofNoNetworkButton',
    _('Image files')+' (*.bmp)|*.bmp',
    sFile)) then exit;
  GGForm_eIconFile.Text:=sFile;
  GGForm_butSave.Enabled:=true;
end;

procedure butOkOnClick(sender:TObject); //vlastni export obrazku
begin
  //funkce se jen vraci s navratovou hodnotou 0, coz znamena pokracovat v exportu
end;

procedure CfgDlgInit;
begin
  CfgToDlg();
  //nastaveni obsluhy dialogu
  GGForm_butCfgFile.OnClick:=@butCfgFileOnClick;
  GGForm_butSave.OnClick:=@butSaveOnClick;
  GGForm_butNoSave.OnClick:=@butNoSaveOnClick;
  GGForm_butOk.OnClick:=@butOkOnClick;
  //Tab Export
  GGForm_butDir.OnClick:=@butDirOnClick;
  GGForm_cbExportType.OnChange:=@OnChange;
  GGForm_eDirOut.OnChange:=@OnChange;
  GGForm_cbSubDir.OnChange:=@OnChange;
  GGForm_eNameLength.OnChange:=@OnChange;
  GGForm_bResize.OnClick:=@OnChange;
  GGForm_cbGps.OnChange:=@OnChange;
  GGForm_eWidth.OnChange:=@OnChange;
  GGForm_eHeight.OnChange:=@OnChange;
  GGForm_bAutorotate.OnClick:=@OnChange;
  GGForm_bAspectRatio.OnClick:=@OnChange;
  GGForm_eIconFile.OnChange:=@OnChange;
  GGForm_butIconFile.OnClick:=@butIconFileOnClick;
  GGForm_eDistance.OnChange:=@OnChange;
  GGForm_eAzimut.OnChange:=@OnChange;
  GGForm_bCorrected.OnClick:=@OnChange;
  GGForm_bHint.OnClick:=@OnChange;
  GGForm_bIdTag.OnClick:=@OnChange;
  //Tab Import
  GGForm_rUpdate.OnClick:=@OnChange;
  GGForm_eDays.OnChange:=@OnChange;
  GGForm_cbUpdate.OnChange:=@OnChange;
  GGForm_bOffline.OnClick:=@OnChange;
  GGForm_rPattern.OnClick:=@OnChange;
  GGForm_ePattern.OnChange:=@OnChange;
  GGForm_bReloadImg.OnClick:=@OnChange;
  //Tab Start/End
  GGForm_bSilent.OnClick:=@OnChange;
  GGForm_rEraseOffline.OnClick:=@OnChange;
  GGForm_rEraseTransform.OnClick:=@OnChange;

      //pri POI bude dostupny vystupni soubor a panel Waypointy v GPX pro POI
  OnChange(nil); //povolime ovladaci prvky
  GGForm_butSave.Enabled:=false;
  GGForm_butNoSave.Visible:=false;

end;